> For the complete documentation index, see [llms.txt](https://docs.ionos.com/reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ionos.com/reference/readme.md).

# Overview

## Developer Reference

Learn about APIs, SDKs, and Configuration Management tools. Empower your innovation with our developer-friendly tools and resources.

## Application Programming Interfaces (APIs)

IONOS Infrastructure as a Service (IaaS) solutions can be managed through APIs, in addition to the Data Center Designer (DCD) web-based application. The <code class="expression">space.vars.ionos\_cloud\_api</code> provides consistent concepts and features, delivers power and flexibility, and can be used to perform a multitude of management tasks, including adding servers, volumes, and configuring networks. This API enables programmatic access to manage and control various aspects of cloud infrastructure. You can start using the <code class="expression">space.vars.ionos\_cloud\_api</code>s directly after getting authenticated. For more information, see [<mark style="color:blue;">Get Started with IONOS Cloud API</mark>](/reference/get-started.md).

## Software Development Kits (SDKs)

<code class="expression">space.vars.ionos\_cloud</code> SDKs provide a set of libraries to allow a seamless integration with <code class="expression">space.vars.ionos\_cloud</code> services, and provide all the components needed to streamline the development process. The built-in security features and best practices implemented within the SDKs safeguard your applications and data. For more information, see [<mark style="color:blue;">SDK Bundles Documentation</mark>](/reference/software-development-kits/sdks/sdk-bundles.md).

## Configuration Management Tools

<code class="expression">space.vars.ionos\_cloud</code> offers a comprehensive suite of Configuration Management Tools providing users with solutions for seamless integration and efficient management of their cloud resources. The Configuration Management Tools provide all utilities required to simplify and automate resource management that allows users to gain the ability to efficiently provision, configure, and manage their infrastructure. You can ensure configuration consistency across environments and effectively manage your cloud infrastructure in a scalable manner. For more information, see [<mark style="color:blue;">Configuration Management Tools Documentation</mark>](/reference/config-management-tools/config-management-tools.md).

{% hint style="info" %}
**Note:**

* APIs, SDKs, and Configuration Management Tools support both **Basic Authentication** and **Bearer Token Authentication**. The user accounts with currently **2FA enabled** or **forced** need to use the **Bearer Token Authentication** method.
* The **Basic Authentication** method will be discontinued in the near future and it should be used in combination with **2FA** to increase security.
  {% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.ionos.com/reference/readme.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
